﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CleverExportadorExcel
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }
        
        /// <summary>
        /// Carga el Form
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void frmMain_Load(object sender, EventArgs e)
        {
            configuraArchivoExcel();
        }

        /// <summary>
        /// Control del Botón Exportar Socios
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnExportarSocios_Click(object sender, EventArgs e)
        {
            DataTable datosSocios;
            Logica_EEX.Socios objLogicaSocios = new Logica_EEX.Socios();

            /*Creo el DataTable a Exportar*/
            datosSocios = objLogicaSocios.TraerTodo();

            exportarExcel(datosSocios);
        }

        /// <summary>
        /// Control del Botón Exportar Inscripciones
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnExportarInscripciones_Click(object sender, EventArgs e)
        {
            DataTable datosInscripciones;
            Logica_EEX.Inscripciones objLogicaInscripciones = new Logica_EEX.Inscripciones();

            try
            {
                /*Creo el DataTable a Exportar*/
                datosInscripciones = objLogicaInscripciones.TraerTodo();

                exportarExcel(datosInscripciones);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error: " + ex);
            }
        }

        /// <summary>
        /// Control del botón exportar
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnCerrar_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        /// <summary>
        /// Configura los parámetros del Archivo Excel
        /// </summary>
        private void configuraArchivoExcel()
        {
            saveFileDialogExcel.Title = "Guardar Archivo Excel";
            saveFileDialogExcel.AddExtension = true;
            saveFileDialogExcel.DefaultExt = ".xlsx";
            saveFileDialogExcel.FileName = "Socios";
            saveFileDialogExcel.Filter = "Archivo de Excel 2007 (*.xlsx)|*.xlsx";
            saveFileDialogExcel.InitialDirectory = System.Environment.GetFolderPath(Environment.SpecialFolder.Personal);
        }

        /// <summary>
        /// Exporta a Excel el DataTable con los filtros seleccionados
        /// </summary>
        private void exportarExcel(DataTable datosAExportar)
        {
            string fechaActual;
            string nombreHojaExcel;

            /*Asigno un nombre de Archivo*/
            fechaActual = DateTime.Now.ToString("yyyyMMdd_HHmm");
            saveFileDialogExcel.FileName = saveFileDialogExcel.FileName + '_' + fechaActual;


            if (saveFileDialogExcel.ShowDialog() == DialogResult.OK)
            {                                
                Logica_EEX.ArchExcel objLogicaArchExcel = new Logica_EEX.ArchExcel();

                /*Asigno Nombre a la Hoja de Excel*/
                nombreHojaExcel = fechaActual;

                if (nombreHojaExcel.Length >= 31)
                {
                    //Las hojas de Excel permiten nombres de longitud menor a 31
                    nombreHojaExcel = nombreHojaExcel.Substring(0, 30);
                }

                objLogicaArchExcel.guardarArchivoExcel(datosAExportar, nombreHojaExcel, saveFileDialogExcel.FileName);

                frmAbrirArchivo objAbrirArch = new frmAbrirArchivo();

                if (objAbrirArch.ShowDialog() == DialogResult.OK)
                {
                    System.Diagnostics.Process.Start(saveFileDialogExcel.FileName);
                }
            }
        }

    }
}
