﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;

namespace Datos_EEX
{
    public class Inscripciones
    {
        /// <summary>
        /// Devuelve DataTable con los socios a Exportar
        /// </summary>
        /// <returns></returns>
        public DataTable TraerTodo()
        {
            DataTable dt = new DataTable();
            string strSQL = 
                           "SELECT " +
                           "u.NroPasaporte  AS 'Nro_Pasaporte', " +
                           "RTRIM(LTRIM(u.Apellido)) AS 'Apellido', " +
                           "RTRIM(LTRIM(u.Nombres)) AS 'Nombre', " +
                           "i.IdInscripcion AS 'IdInscripcion', " +
                           "i.NroGrupo AS 'NroGrupo', " +
                           "i.NroUsuario AS 'NroUsuario'," +
                           "CONVERT (VARCHAR(10), i.fecha, 120)  AS 'Fecha', " +
                           "CONVERT (VARCHAR(10), i.fechahasta, 120)  AS 'Fecha Hasta'," +      
                           "t.Descripcion AS 'Descipcion', " +
                           "i.Idsubgrupo AS 'IdSubgrupo' " +
                           "FROM Usuarios u, inscripciones i, programas p, programas_tarifas t " +
                           "WHERE " +
                           "u.nrogrupo=i.nrogrupo " +
                           "AND i.idprograma=p.idprograma " +
                           "AND u.nrousuario=i.nrousuario " +
                           "AND p.idprograma=t.idprograma " +
                           "AND i.idtarifa=t.idtarifa " +
                           "AND  u.estado<>'B' " +
                           "AND i.estado='A' " +
                           "AND u.PasapVigenciaH >getdate() " +
                           "AND i.fecha>='20150101' ";


            try
            {
                SqlDataAdapter daTraer = new SqlDataAdapter(strSQL, Conexion.strConexion);
                daTraer.Fill(dt);
            }
            catch (SqlException ex)
            {
                //Se produjo un error SQL, SqlExcepcion es especifico de sql por eso va arriba de Excepcion
                throw new Exception("Error en la Base de Datos: ", ex);
            }
            catch (Exception)
            {
                //Pasa la excepción a la capa de lógica
                throw new Exception("No pudo realizar traer todas las Inscripciones de la base");
            }

            return dt;
        }
    }
}
